%% recursive sample: 7/31/97 - 1/31/10: 151 total
% discrepancy between GB closed dates and projection dates
% 1/31/96: December CPI release NOT yet available: USE 2/1/96 release  
% definition of {0,1,2}:
% var(1) var(2) var(3) var(4): let var(1) be the only QF variable
%   0     +2      +2     +3  : denote as "0" : 3rd release  
%   0      0       0     +1  : denote as "1" : 1st release
%   0     +1      +1     +2  : denote as "2" : 2nd release
%

load results_RS_AR2.mat    
load results_RS_QFBVAR.mat  
load results_RS_MFBVAR.mat

nrs = 151;

% SS_index starts from 1994:M3, but we want to use it from 1997:M7
%SS_index = SS_index(38:nrs+37);
SS_index = SS_index(38:38+nrs-1);
SS_index(28)  = 4;
SS_index(29)  = 4;
SS_index(33)  = 4;
SS_index(145) = 4;

% store RMSE_vector: 
RMSE_MF2_G_vector = zeros(sum(SS_index==2),8,11);
RMSE_MF2_L_vector = zeros(sum(SS_index==2),8,11);
FG2_vector        = FG_vector((SS_index==2)==1,:,:);
FL2_vector        = FL_vector((SS_index==2)==1,:,:);
RMSE_MF0_G_vector = zeros(sum(SS_index==0),8,11);
RMSE_MF0_L_vector = zeros(sum(SS_index==0),8,11);
FG0_vector        = FG_vector((SS_index==0)==1,:,:);
FL0_vector        = FL_vector((SS_index==0)==1,:,:);
RMSE_MF1_G_vector = zeros(sum(SS_index==1),8,11);
RMSE_MF1_L_vector = zeros(sum(SS_index==1),8,11);
FG1_vector        = FG_vector((SS_index==1)==1,:,:);
FL1_vector        = FL_vector((SS_index==1)==1,:,:);

RMSE_MF2 = zeros(sum(SS_index==2),8,11);
RMSE_QF2 = zeros(sum(SS_index==2),8,11);
RMSE_MF0 = zeros(sum(SS_index==0),8,11);
RMSE_QF0 = zeros(sum(SS_index==0),8,11);
RMSE_MF1 = zeros(sum(SS_index==1),8,11);
RMSE_QF1 = zeros(sum(SS_index==1),8,11);

RMSE_QF2_G_vector = zeros(sum(SS_index==2),8,11);
RMSE_QF2_L_vector = zeros(sum(SS_index==2),8,11);
RMSE_QF0_G_vector = zeros(sum(SS_index==0),8,11);
RMSE_QF0_L_vector = zeros(sum(SS_index==0),8,11);
RMSE_QF1_G_vector = zeros(sum(SS_index==1),8,11);
RMSE_QF1_L_vector = zeros(sum(SS_index==1),8,11);

RMSE_AR2_G_vector = zeros(sum(SS_index==2),8,11);
RMSE_AR2_L_vector = zeros(sum(SS_index==2),8,11);
RMSE_AR0_G_vector = zeros(sum(SS_index==0),8,11);
RMSE_AR0_L_vector = zeros(sum(SS_index==0),8,11);
RMSE_AR1_G_vector = zeros(sum(SS_index==1),8,11);
RMSE_AR1_L_vector = zeros(sum(SS_index==1),8,11);

FG2_vector50 = FG_vector50((SS_index==2)==1,:,:);
FL2_vector50 = FL_vector50((SS_index==2)==1,:,:);
FG0_vector50 = FG_vector50((SS_index==0)==1,:,:);
FL0_vector50 = FL_vector50((SS_index==0)==1,:,:);
FG1_vector50 = FG_vector50((SS_index==1)==1,:,:);
FL1_vector50 = FL_vector50((SS_index==1)==1,:,:);

FGQ2_vector50 = FGQ_vector50((SS_index==2)==1,:,:);
FLQ2_vector50 = FLQ_vector50((SS_index==2)==1,:,:);
FGQ0_vector50 = FGQ_vector50((SS_index==0)==1,:,:);
FLQ0_vector50 = FLQ_vector50((SS_index==0)==1,:,:);
FGQ1_vector50 = FGQ_vector50((SS_index==1)==1,:,:);
FLQ1_vector50 = FLQ_vector50((SS_index==1)==1,:,:);

FGA2_vector50 = FGA_vector50((SS_index==2)==1,:,:);
FLA2_vector50 = FLA_vector50((SS_index==2)==1,:,:);
FGA0_vector50 = FGA_vector50((SS_index==0)==1,:,:);
FLA0_vector50 = FLA_vector50((SS_index==0)==1,:,:);
FGA1_vector50 = FGA_vector50((SS_index==1)==1,:,:);
FLA1_vector50 = FLA_vector50((SS_index==1)==1,:,:);


pickL = [ 1 0 0 0 0 1 1 0 0 0 0];

for ii=1:sum(SS_index==2)   
    for j=1:11
    % MF BVAR RMSE COMPUTATION        
    RMSE_MF2_G_vector(ii,:,j) = ((4*FG2_vector50(ii,:,j)-4*FG2_vector(ii,:,j)));
    RMSE_MF2_L_vector(ii,:,j) = ((100*FL2_vector50(ii,:,j)-100*FL2_vector(ii,:,j)));       
    
    % QF BVAR RMSE COMPUTATION
    RMSE_QF2_G_vector(ii,:,j)  = ((4*FGQ2_vector50(ii,:,j)-4*FG2_vector(ii,:,j)));
    RMSE_QF2_L_vector(ii,:,j)  = ((100*FLQ2_vector50(ii,:,j)-100*FL2_vector(ii,:,j)));

    % AR2 RMSE COMPUTATION
    RMSE_AR2_G_vector(ii,:,j)  = ((4*FGA2_vector50(ii,:,j)-4*FG2_vector(ii,:,j)));
    RMSE_AR2_L_vector(ii,:,j)  = ((100*FLA2_vector50(ii,:,j)-100*FL2_vector(ii,:,j)));        
    end
    RMSE_MF2(ii,:,:) = [squeeze(RMSE_MF2_L_vector(ii,:,pickL==1)) squeeze(RMSE_MF2_G_vector(ii,:,pickL==0))];
    RMSE_QF2(ii,:,:) = [squeeze(RMSE_QF2_L_vector(ii,:,pickL==1)) squeeze(RMSE_QF2_G_vector(ii,:,pickL==0))];
end


for ii=1:sum(SS_index==0)    
    for j=1:11
    % MF BVAR RMSE COMPUTATION        
    RMSE_MF0_G_vector(ii,:,j) = ((4*FG0_vector50(ii,:,j)-4*FG0_vector(ii,:,j)));
    RMSE_MF0_L_vector(ii,:,j) = ((100*FL0_vector50(ii,:,j)-100*FL0_vector(ii,:,j)));       
    
    % QF BVAR RMSE COMPUTATION
    RMSE_QF0_G_vector(ii,:,j)  = ((4*FGQ0_vector50(ii,:,j)-4*FG0_vector(ii,:,j)));
    RMSE_QF0_L_vector(ii,:,j)  = ((100*FLQ0_vector50(ii,:,j)-100*FL0_vector(ii,:,j)));

    % AR2 RMSE COMPUTATION
    RMSE_AR0_G_vector(ii,:,j)  = ((4*FGA0_vector50(ii,:,j)-4*FG0_vector(ii,:,j)));
    RMSE_AR0_L_vector(ii,:,j)  = ((100*FLA0_vector50(ii,:,j)-100*FL0_vector(ii,:,j)));    
    end
    RMSE_MF0(ii,:,:) = [squeeze(RMSE_MF0_L_vector(ii,:,pickL==1)) squeeze(RMSE_MF0_G_vector(ii,:,pickL==0))];
    RMSE_QF0(ii,:,:) = [squeeze(RMSE_QF0_L_vector(ii,:,pickL==1)) squeeze(RMSE_QF0_G_vector(ii,:,pickL==0))];
end


for ii=1:sum(SS_index==1)    
    for j=1:11
    % MF BVAR RMSE COMPUTATION        
    RMSE_MF1_G_vector(ii,:,j) = ((4*FG1_vector50(ii,:,j)-4*FG1_vector(ii,:,j)));
    RMSE_MF1_L_vector(ii,:,j) = ((100*FL1_vector50(ii,:,j)-100*FL1_vector(ii,:,j)));       
    
    % QF BVAR RMSE COMPUTATION
    RMSE_QF1_G_vector(ii,:,j)  = ((4*FGQ1_vector50(ii,:,j)-4*FG1_vector(ii,:,j)));
    RMSE_QF1_L_vector(ii,:,j)  = ((100*FLQ1_vector50(ii,:,j)-100*FL1_vector(ii,:,j)));

    % AR2 RMSE COMPUTATION
    RMSE_AR1_G_vector(ii,:,j)  = ((4*FGA1_vector50(ii,:,j)-4*FG1_vector(ii,:,j)));
    RMSE_AR1_L_vector(ii,:,j)  = ((100*FLA1_vector50(ii,:,j)-100*FL1_vector(ii,:,j)));    
    end
    RMSE_MF1(ii,:,:) = [squeeze(RMSE_MF1_L_vector(ii,:,pickL==1)) squeeze(RMSE_MF1_G_vector(ii,:,pickL==0))];
    RMSE_QF1(ii,:,:) = [squeeze(RMSE_QF1_L_vector(ii,:,pickL==1)) squeeze(RMSE_QF1_G_vector(ii,:,pickL==0))];
end


RMSE_MF2_LD = zeros(8,1);
RMSE_QF2_LD = zeros(8,1);
RMSE_MF0_LD = zeros(8,1);
RMSE_QF0_LD = zeros(8,1);
RMSE_MF1_LD = zeros(8,1);
RMSE_QF1_LD = zeros(8,1);

for hh=1:8
    
    object = RMSE_MF2;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_MF2_LD(hh,:) = log(det(mtemp));
    
    object = RMSE_QF2;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_QF2_LD(hh,:) = log(det(mtemp));
    
    object = RMSE_MF1;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_MF1_LD(hh,:) = log(det(mtemp));
    
    object = RMSE_QF1;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_QF1_LD(hh,:) = log(det(mtemp));    
    
    
    object = RMSE_MF0;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_MF0_LD(hh,:) = log(det(mtemp));
    
    object = RMSE_QF0;    
    n2 = size(object,1);
    temp = zeros(n2,11,11);    
    for jj=1:n2
        temp(jj,:,:) = reshape(squeeze(object(jj,hh,:)),[],1)*reshape(squeeze(object(jj,hh,:)),1,[]);
    end
    mtemp = squeeze(mean(temp,1));
    RMSE_QF0_LD(hh,:) = log(det(mtemp));    
end
        
RMSE_MF1_LD = RMSE_MF1_LD/(2*11);
RMSE_MF2_LD = RMSE_MF2_LD/(2*11);
RMSE_MF0_LD = RMSE_MF0_LD/(2*11);

RMSE_QF1_LD = RMSE_QF1_LD/(2*11);
RMSE_QF2_LD = RMSE_QF2_LD/(2*11);
RMSE_QF0_LD = RMSE_QF0_LD/(2*11);


scrsz = get(0,'ScreenSize');

fig=figure('Position',[20,20,900,600],'Name',...
         'RMSE','Color','w',...
         'Position',[1 scrsz(4)/13 scrsz(3) scrsz(4)/1.5]);
subplot(1,2,1)
hold on;
plot(RMSE_MF1_LD(1:8,:),'Marker','o','Color',[0.9 0.2 0.1],'LineStyle','-','LineWidth',3)
plot(RMSE_MF2_LD(1:8,:),'Marker','s','Color',[0.2 0.8 0.2],'LineStyle','--','LineWidth',4)
plot(RMSE_MF0_LD(1:8,:),'Color',[0.1 0.2 0.9],'LineStyle','-','LineWidth',3)
gg=legend('+0 Months','+1 Months','+2 Months');
set(gg,'location','southeast','FontSize',15);
set(gg,'Interpreter','latex');
legend('boxoff')
title('MF-VAR','Interpreter','latex','FontSize',15);
xlabel('Forecast Horizon','Interpreter','latex','FontSize',15);
ylabel('Log Determinant','Interpreter','latex','FontSize',15);
hold on
line([1 8],[0 0],'Color',[0.6 0.6 0.6],'LineStyle','--','LineWidth',2)
%axis([1 8 -30 5])
axis([1 8 min(RMSE_MF0_LD(1:8,:)) max(RMSE_MF0_LD(1:8,:))]);
set(gca,'FontSize',15)
subplot(1,2,2)
hold on;
plot(RMSE_QF1_LD(1:8,:),'Marker','o','Color',[0.9 0.2 0.1],'LineStyle','-','LineWidth',3)
plot(RMSE_QF2_LD(1:8,:),'Marker','s','Color',[0.2 0.8 0.2],'LineStyle','--','LineWidth',4)
plot(RMSE_QF0_LD(1:8,:),'Color',[0.1 0.2 0.9],'LineStyle','-','LineWidth',3)
gg=legend('+0 Months','+1 Months','+2 Months');
set(gg,'location','southeast','FontSize',15);
set(gg,'Interpreter','latex');
legend('boxoff')
title('QF-VAR','Interpreter','latex','FontSize',15);
xlabel('Forecast Horizon','Interpreter','latex','FontSize',15);
ylabel('Log Determinant','Interpreter','latex','FontSize',15);
hold on
line([1 8],[0 0],'Color',[0.6 0.6 0.6],'LineStyle','--','LineWidth',2)
%axis([1 8 -30 5])
axis([1 8 min(RMSE_MF0_LD(1:8,:)) max(RMSE_MF0_LD(1:8,:))]);
set(gca,'FontSize',15)


fig=figure('Position',[20,20,900,600],'Name',...
         'RMSE','Color','w',...
         'Position',[1 scrsz(4)/13 scrsz(3)/2.0 scrsz(4)/1.5]);
hold on;
hold on;
plot(100*(RMSE_MF1_LD(1:8,:)-RMSE_QF1_LD(1:8,:)),'Marker','o','Color',[0.9 0.2 0.1],'LineStyle','-','LineWidth',3)
plot(100*(RMSE_MF2_LD(1:8,:)-RMSE_QF2_LD(1:8,:)),'Marker','s','Color',[0.2 0.8 0.2],'LineStyle','--','LineWidth',4)
plot(100*(RMSE_MF0_LD(1:8,:)-RMSE_QF0_LD(1:8,:)),'Color',[0.1 0.2 0.9],'LineStyle','-','LineWidth',3)
gg=legend('+0 Months','+1 Months','+2 Months');
set(gg,'location','southeast','FontSize',16);
set(gg,'Interpreter','latex');
legend('boxoff')
%title('Inflation','Interpreter','latex','FontSize',15);
xlabel('Forecast Horizon','Interpreter','latex','FontSize',16);
ylabel('Relative Log Determinant','Interpreter','latex','FontSize',16);
hold on
line([1 8],[0 0],'Color',[0.6 0.6 0.6],'LineStyle','--','LineWidth',2)
axis([1 8 -100 10])
%axis([1 8 min(100*(RMSE_MF0_G(1:8,3)-RMSE_QF0_G(1:8,3))./RMSE_QF0_G(1:8,3)) 1.1]);
set(gca,'FontSize',15)


%%



